<?php

class EasyCodeAdmin extends EasyCode {
	var $adminname = 'EasyCodeAdminOption';
	var $option;
	var $lang_list_to_load = array();

	function __construct(){
		parent::__construct();
		//Something more
	}

	function EasyCodeAdmin(){
		$this->__construct();
	}

	function print_codebox($content,$title='',$lang=''){
		$option = $this->getOptions();
		if(is_admin()){
			$box = "<div class=\"easycodebox_simple\">
			<div class=\"title\"><small>{$lang}</small>{$title}</div>
			<pre class=\"main\">{$content}</pre>
			</div>";
			$this->printsimpleCSS();
		}
	}

	function printsimpleCSS(){
		$option = getOptions();
		include_once 'include-extra-file-admin.php';
	}

	function printAdminPage(){
		include_once 'adminpage/adminpage.php';
	}

	function color_handler($color){
		$strhandler=function($cstr){
			$cstr = preg_replace('/[^0-9A-F]/S','',strtoupper($cstr));
			$len = strlen($cstr);
			if($len>=6){
				$cstr=substr($cstr,0,6);
			}else if($len<6 && $len>=3){
				$cstr=substr($cstr,0,3);
			}else if($len<3 && $len>0){
				$fc=substr($cstr,0,1);
				$cstr=$fc.$fc.$fc;
			}else{
				$cstr='fff';
			}
			return $cstr;
		};

		if(is_array($color)){
			foreach($color as $key=>$value){
				$color[$key]=$strhandler($value);
			}
		}else{
			$color=$strhandler($color);
		}
		return $color;
	}


	function CreateAdminMenu(){
		add_options_page('EasyCode','EasyCode Options','manage_options',$this->pluginname, array(&$this , 'printAdminPage'));
	}


	//TinyMCE
	function mce_add() {
		$option = $this->getOptions();
		if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') ) return;
		// Add only in Rich Editor mode
		if ( get_user_option('rich_editing') == 'true') {
			add_filter('mce_css',array($this,'mce_add_css'));
			add_filter("mce_external_plugins", array($this,'mce_add_plugin'));

			if($option['mce-button-row-position']>0)
				add_filter('mce_buttons'.($option['mce-button-row-position']==1?'':'_2'), array($this,'mce_register_button'));
		}
	}
	function mce_add_css($csslist){
		if(!empty($csslist)) $csslist.=',';
		$csslist.=$this->plugindir.'/mce/mce_add_style.css';
		return $csslist;
	}
	function mce_register_button($buttons) {//Load the button
		$buttons[] = "easycode_box";
		return $buttons;
	}
	function mce_add_plugin($plugin_array) {// Load the TinyMCE plugin : editor_plugin.js
		$plugin_array['easycode_box'] = $this->plugindir.'/mce/editor_plugin.js';
		return $plugin_array;
	}

	// Add a link to the option page in Plugin menu
	function plugin_action_links($links, $file) {
		if ( $file == $this->flodername.'/easycode.php' ) {
			$links[] = '<a href="options-general.php?page=EasyCode">'.__('Options').'</a>';
		}
		return $links;
	}

}


?>