<?php
// Beginning of the class defination.
class EasyCode {

var $adminname = 'EasyCodeAdminOption';
var $pluginname = 'EasyCode';
var $plugindir = '';
var $plugin_path = '';
var $flodername = 'easycode';
var $version = '1.5.1';
var $about_url = 'http://wordpress.org/plugins/easycode/';
var $option = array();

function __construct(){
	$this->flodername = basename(dirname(__FILE__));
	$this->plugindir = plugins_url('',__FILE__);//NOTICE the '/'
	$this->plugin_path = dirname(__FILE__);//NOTICE the '/'
	load_plugin_textdomain('easycode', false,$this->flodername.'/lang');
}

function getOptions(){
	if(!$this->option){ //Cache is avaliable?
		$this->option = $this->read_options();
	}
	return $this->option;
}

function read_options(){
	$default_option = array(
		'hidecode'=>0,
		'collapsed-line-number'=>8,
		'rownum'=>2,
		'html_tag_p'=>0,
		'handle_comments'=>1,
		'edit_code'=>2,
		'nowrap'=>1,
		'tab-size'=>4,
		'size'=>array('width'=>0,'height'=>0),
		'use_custom_color'=>0,
		'system_color'=>'Gray',
		'color'=>array('bg'=>'f7f7f7','bga'=>'fff','text'=>'666','texta'=>'336699','side'=>'ccc','border'=>'666'),
		'border-width'=>1,
		'formatted'=>array('bb'=>0,'pre'=>1,'code'=>0),
		'highlighter'=>1,
		'hlcolor'=>array('function'=>'00f','keyword'=>'f00','comment'=>'888','important'=>'f0f','string'=>'080','constant'=>'880','number'=>'808','variable'=>'088','symbol'=>'800','char'=>'80f'),
		'lang_enable'=>array('php','html','javascript','css'),
		'mce-button-row-position'=>1,
		'font_style'=>'consolas',
		'font-size'=>'90',
		'allow-download-font'=>true,
	);

	$raw_option = get_option($this->adminname);
	if(!is_array($raw_option)) $raw_option=array();

	if($raw_option){
		//Fill missing items with default values,Relaxed but fast
		if(count(array_diff(array_keys($default_option), array_keys($raw_option)))){
			$option = $raw_option + $default_option;
			update_option($this->adminname,$option);
		}else{
			$option = $raw_option;
		}
	}else{
		//There is no saved value in database
		$option = $default_option;
		update_option($this->adminname,$default_option);
	}

	//print_r($option);
	$this->option = $option;
	return $option;
}


function EasyCode(){ // For PHP4
	$this->__construct();
}


/*** Filter function for content of posts and comments *****/

function CommentHandler($text){
	$o = $this->getOptions();
	if($o['handle_comments']) $text = $this->PostHandler($text);
	return $text;
}

function PostHandler($text){
	$option = $this->getOptions();
	$formatted = $option['formatted'];

	//tag in new version
	$parent_this = &$this;
	if($formatted['pre']){
		$text = preg_replace_callback(
			"/\s?<pre class=\"easycode;([^\n]*)\">[\s]?(.+?)[\s]?<\/pre>\s?/is",
			function($matches) use(&$parent_this){
				return $parent_this->codedisp($matches[2],$matches[1],'pre');
			},
			$text,-1,$replace_count_2
		);
	}

	return $text;
}

function codedisp($content,$class_string,$tag='pre'){
	//Prase paraments which is written in class name
	//Other data filters
	//Then pass them to other functions to get final output HTML
	$option = $this->getOptions();
	$attrs = array('title'=>'','lang'=>'');

	$content = str_replace("\t",str_repeat('&nbsp;',4),$content);

	//transform class-name string to attr-array
	$class_a = explode(';',trim($class_string));
	foreach($class_a as $value){
		if($value && trim($value)){
			$offset = strpos($value,':');
			$attrs[trim(substr($value,0,$offset))] = substr($value,$offset+1);
		}
	}

	if(is_admin()){
		return $this->print_codebox_admin($content,$attrs);
	}elseif(is_feed()){
		return $this->print_codebox_feed($content,$attrs);
	}else{
		return $this->print_codebox($content,$attrs);
	}
}

function print_codebox($content,$attrs){
	$option = $this->getOptions();
	$title = $attrs['title'];
	$lang = $attrs['lang'];
	// Set HTML tag to be output according to the active highlighter
	// Use $flag variable 
	if($option['highlighter'] == 0){
		// No highlight active
		$html_parent_tags= array('<ol>','</ol>'); 
		$html_child_tags = array("\n<li>",'</li>'); 
	}else{
		// Valid language 
		if($lang && in_array($lang,$option['lang_enable']) && $this->get_language_map($lang,'name')){
			switch($option['highlighter']){
			case 2://GeSHi
				$content = str_replace('&nbsp;', ' ', $content);
				$content = $this->highlight_geshi($content,$this->get_language_map($lang,'geshi'));
				$html_parent_tags= array('<ol>','</ol>'); 
				$html_child_tags = array("\n<li>",'</li>'); 
				break;
			case 1://SHJS
				$html_parent_tags= array('<pre class="brush:'.$this->get_language_map($lang,'sh').';">','</pre>'); 
				$html_child_tags = array("\n",''); 
				break;
			default:
				$html_parent_tags= array('<ol>','</ol>'); 
				$html_child_tags = array("\n<li>",'</li>'); 
				break;
			}
		}else{// Invalid language
			$html_parent_tags= array('<ol>','</ol>'); 
			$html_child_tags = array("\n<li>",'</li>'); 
		}
	}
	// $content = str_replace(' ', '&nbsp;', $content);
	// After use 'white-space:pre' in CSS, the operation is aborted.

	$guideword = __('Click here to show/hide the code.','easycode');
	//Add html tag to every line of code. 
	$HTML_tag_allowed = '<b><i><em><del><u><strong><strike><span>';
	$line_number_counter = 0;
	$main = preg_replace_callback("/[\n\r]*([^\n\r]+)[\n\r]*/ism",
		function($matches) use ($HTML_tag_allowed,$html_child_tags) {
			return $html_child_tags[0]. strip_tags($matches[1],$HTML_tag_allowed). $html_child_tags[1];
		},
		$content, -1, $line_number_counter);

	//output CodeBoxID
	static $boxid=0;
	$boxid++;
	echo "<script>ecbox_number=$boxid;</script>";
	$html_templete = "
	<div class='easycodebox %s %s' id='easycodebox-%d'>
	<div class='headbar' onclick='EasyCodeClass(this).ShowCode();' %s>%s</div>
	<div class='flex-box'>
	<div class='scrollbox' %s>
	<div class='ecside'>&nbsp;</div>
	<div class='main'>{$html_parent_tags[0]}%s{$html_parent_tags[1]}</div>
	</div></div></div>";

	// Read $atrrs, conclude whether block is collapsed.
	$is_collapsed = $option['hidecode'];
	if($line_number_counter < $option['collapsed-line-number']){
			$is_collapsed = false;
	}
	if(isset($attrs['collapsed'])){
		if(!$attrs['collapsed'] or trim($attrs['collapsed'])=='false'){
			$is_collapsed = false;
		}else{
			$is_collapsed = true;
		}
	}

	$box = vsprintf($html_templete,
		array(
			$is_collapsed ?'hidecode':'' ,
			$lang,
			$boxid,
			$title?' title="'.$guideword.'"':'',
			$title?$title:"<span class='message'>&nbsp;</span>",
			$option['edit_code']?' ondblclick="EasyCodeClass(this).editCode(1);"':'',
			$main,
		)
	);

	//Import CSS and JS
	$this->include_extra_file();
	//import CSS & JS for highlighter
	if($option['highlighter']==3||$option['highlighter']==1){
		$this->include_extra_file_highlighter($lang);
	}
	//Return HTML
	return $box;
}
function print_codebox_admin($content,$attrs){
	// HTML for admin
	$box = "<div class=\"easycodebox_simple\">
		<div class=\"title\"><small>{$attrs[lang]}</small>{$attrs[title]}</div>
		<pre class=\"main\">{$content}</pre>
		</div>";
	$this->include_extra_file_admin();
	return $box;
}
function print_codebox_feed($content,$attrs){
	// CodeBox for RSS Dispaly
	$box = "<pre>{$content}</pre>";
	return $box;
}

/********** Import CSS and JS **********/
//Basic stylesheets and javascript
function include_extra_file(){
	$option = $this->getOptions();
	include_once 'include-extra-file.php';
}
//for admin
function include_extra_file_admin(){
	$option = $this->getOptions();
	include_once 'include-extra-file-admin.php';
}

//Import files relative to highlighters based on javascript.
function include_extra_file_highlighter($parameter){
	if(!$parameter) return false;
	$option = $this->getOptions();
	$purl = "$this->plugindir";
	static $lang_printed_list = array();
	// The variable {$lang_printed_list} will save all language JS files that have been printed. 
	if(!in_array($parameter,$lang_printed_list) && array_uintersect($option['lang_enable'],array($parameter),"strcasecmp")){
		// If the language is avaliable, load it.
		// Load various files according which highlighter is active.
		switch($option['highlighter']){
			case 3: 
				wp_enqueue_script('easycode_highlight',"$purl/highlight.js");
				wp_enqueue_script("easycode_highlight_lang_$parameter","$purl/langLib/{$parameter}.eclang.js");
			break;
			case 1: 
				wp_enqueue_script('easycode_highlight_sh',$this->plugindir.'/sh/shCore.js');
				wp_enqueue_script("easycode_hl_sh_lang_$parameter", $purl.'/sh/shBrush'.$this->get_language_map($parameter,'SH_FILE').'.js');
			break;
			default:return false;
		}

		array_push($lang_printed_list,$parameter);
	}
}

/*function printCSS($op='common',$parameter=''){
	$option = $this->getOptions();
	switch($op){
	case 'lang':
		if($option['highlight'] && $parameter){
			static $lang_printed_list=array();
			if(!in_array($parameter,$lang_printed_list) && array_uintersect($option['lang_enable'],array($parameter),"strcasecmp")){
				echo "<script type=\"text/javascript\" src=\"$this->plugindir/langLib/$parameter.eclang.js\"></script>"; 
				array_push($lang_printed_list,$parameter);
			}
		}
		break;
	default:
		include_once 'include-extra-file.php';
		break;
	}
}*/


/********** GeSHi Highlighter **********/
function include_geshi_class(){
	if(class_exists('GeSHi')){
		//echo "GeSHi Class has been defined!!";
	}else{
		include_once('geshi/geshi.php');
	}
}
function highlight_geshi($content,$lang){
	$this->include_geshi_class();
	$geshi= new GeSHi(htmlspecialchars_decode($content),$lang);
	$geshi->enable_classes();
	$geshi->set_header_type(GESHI_HEADER_NONE);
	return $content = $geshi->parse_code();
}




/**** Add Button For Comment Form ****/
function add_comment_button(){
	if($this->option['handle_comments']){
		include 'mce/comment_button.php';
	}
}



/********** Common Functions **********
 * The following methods are also used in AdminClass *
*/

function get_style_list(){
	$flist = scandir(dirname(__FILE__).'/boxstyles');
	$slist =array();
	foreach($flist as $fname){
		if(substr($fname,-4,4)=='.css'){
			$slist[]=substr($fname,0,-4);
		}
	}
	return $slist;
}

function get_language_list_old(){
	$flist = scandir(dirname(__FILE__).'/langLib');
	$slist =array();
	foreach($flist as $fname){
		if(substr($fname,-3,3)=='.js'){
			$slist[]=str_replace('.eclang.js','',$fname);
		}
	}
	return $slist;
}

function get_language_list(){
	return array('actionscript','ada','autohotkey','applescript','asm','bash','winbatch','bibtex','csharp','clojure','cfm','c','cpp','css','delphi','diff','erlang','fsharp','gnuplot','groovy','javascript','java','latex','lisp','lsl','lua','matlab','objc','perl','php','powershell','python','rsplus','ruby','scala','scheme','sql','tcl','vb','verilog','xml','yaml','avisynth','vbnet','html');
	//$l = array('html','css','javascript','php','sql');	return $l;
}

function get_language_map($lang,$item){
	$map = include $this->plugin_path.'/lang-data.php';
	//Get Data from another file.
	$item_values = array('geshi'=>'GESHI_ID','sh'=>'SH_ID','name'=>'NAME');
	$key = $item_values[$item]?$item_values[$item]:$item;
	//Here need to be more !
	if($map[$lang]) return $map[$lang][$key];
	//name | easycode-id | geshi-id-file | sh-id | sh-file | file-extensions 
}

function get_font_list(){
	return include $this->plugin_path.'/font-data.php';
}

function color_handler($color){
	$strhandler=function($cstr){
		$cstr = preg_replace('/[^0-9A-F]/S','',strtoupper($cstr));
		$len = strlen($cstr);
		if($len>=6){
			$cstr=substr($cstr,0,6);
		}else if($len<6 && $len>=3){
			$cstr=substr($cstr,0,3);
		}else if($len<3 && $len>0){
			$fc=substr($cstr,0,1);
			$cstr=$fc.$fc.$fc;
		}else{
			$cstr='fff';
		}
		return $cstr;
	};

	if(is_array($color)){
		foreach($color as $key=>$value){
			$color[$key]=$strhandler($value);
		}
	}else{
		$color=$strhandler($color);
	}
	return $color;
}




/******** JSON Function ********
  As of PHP 5.2.0, the JSON extension is bundled and compiled into PHP by default.
  PEAR package `Services_JSON` is included for previous versions. (URL:http://pear.php.net/package/Services_JSON) 
*/
function json_decode($json){
	if(!function_exists('json_decode')){
		return json_decode($json,TRUE);
	}else{
		include_once 'json_func.php';
		$obj = new Services_JSON (SERVICES_JSON_LOOSE_TYPE);
		return $obj->decode($json);
	}
}
function json_encode($arr){
	if(!function_exists('json_encode')){
		return json_encode($arr);
	}else{
		include_once 'json_func.php';
		$obj = new Services_JSON (SERVICES_JSON_LOOSE_TYPE);
		return $obj->encodeUnsafe($arr);
	}
}


/********** End of the Class Defination **********/
}

