<?php
/*
Plugin Name: EasyCode
Plugin URI: http://wordpress.org/plugins/easycode
Version: 1.5.1
Author: Bob Green
Text Domain: easycode
Description: EasyCode provides a convenient way insert code to your posts, pages and comments.Your code will be displayed friendly to readers and attached with useful functions and colorful apperance.

*************************
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

if ( !function_exists( 'add_action' ) ) {
	exit;
}

if(!class_exists("EasyCode")){
	include 'class.php';
}
if(!class_exists("EasyCodeAdmin") && is_admin()){
	include 'admin.class.php';
}

//Add actions and filters 

if(is_admin()){
	$ecc=new EasyCodeAdmin();
	add_filter('the_content' , array($ecc,'PostHandler' ));
	add_filter('get_comment_text' , array($ecc,'CommentHandler' ));
	add_action('admin_menu',array($ecc,'CreateAdminMenu'));
	add_filter('plugin_action_links', array($ecc,'plugin_action_links'), 10, 2 );
	add_action('init', array($ecc,'mce_add'));
}else{
	$ecc=new EasyCode();
	add_action('comment_form_after_fields',array($ecc,'add_comment_button'));
	add_action('comment_form_logged_in_after',array($ecc,'add_comment_button'));
	add_filter('the_content' , array($ecc,'PostHandler' ));
	add_filter('get_comment_text' , array($ecc,'CommentHandler' ));
}
