
Array.prototype.toRegExp = function(){
	re = new RegExp('\\b('+this.join('|')+')\\b','g')
	return re;
}

String.prototype.ltrim = function(){
	return this.replace(/^\n|\n$/g,'');
}

String.prototype.toEntities = function(){
	if(!this.length) return this;
	af = this.replace(/&/g,'&amp;').replace(/</g,'&lt;').replace(/>/g,'&gt;');
	//af = af.replace(/&/g,'&amp;').replace(/"/g,'&quot;').replace(/'/g,'&#039;').replace(/ /g,'&nbsp;');
	return af.toString();
}

String.prototype.xreplace = function(search,style,parent){
	search = search.valid();
	if(!parent){
		tags = EasyCodeHighLight.styleToClass(style);
		code = this.replace(search,function(){
			if((arguments[0].search('<')<0)&&(arguments[0].search('<')<0)){
				return tags[0]+arguments[0]+tags[1];
			}else{
				return arguments[0];
			}
		});
	}else{
		parent = parent.valid();
		code = this.replace(parent,function(){return arguments[0].xreplace(search,style);})
	}
	return code;
}

String.prototype.removeHtmlTag = function(n){
	if(n || n===undefined){
		removed = this.replace(/<[^\n<>]+>/igm,'');
	}else{
		removed = this.replace(/<[^\n<>]+>/igm,'\n');
	}
	//remove entities
	removed = removed.replace(/&amp;/g,'&').replace(/&quot;/g,'"').replace(/&#(0)?39;/g,'\'').replace(/&nbsp;/g,' ');
	//removed = removed.replace(/"/g,'&quot;').replace(/'/g,'&#039;').replace(/ /g,'&nbsp;');

	return removed;
}

String.prototype.addHtmlTag = function(nTag){
	if(nTag == undefined){
		a=this;
		a=a.replace(/ (?![^<>]*?>)/g,'&nbsp;')
		a=a.replace(/\r\n/g,'\n').replace(/\r/g,'\n').replace(/^\n|\n$/g,'');
		a=a.replace(/<([^<>]+)>([^<>]+)<\/\1>/g,function(){
			var tag1='<span class="echl-'+arguments[1]+'">',tag2='</span>',content=arguments[2];
			content = content.replace(/\n/g,tag2+'\n'+tag1);
			return tag1+content+tag2;
		});
		a=a.replace(/^.*?$/igm,'<li>$&</li>');
	}
	return a;
}


RegExp.prototype.toEntities = function(){
	source = this.source.toEntities();
	var attributes='g';
	if(this.ignoreCase) attributes = attributes +'i';
	if(this.multiline) attributes = attributes +'m';
	reg = new RegExp(source,attributes);
	return reg;
}

RegExp.prototype.valid = function(){
	source = this.source.toEntities() + '(?![^<>]*?(<\/))(?![^<>]*?>)';
	var attributes='g';
	if(this.ignoreCase) attributes = attributes +'i';
	if(this.multiline) attributes = attributes +'m';
	reg = new RegExp(source,attributes);
	return reg;
}

function creatEasyCodeHighLightClass(){
	this.commonRegex = {
		CmultiLineComments			: /\/\*[\s\S]*?\*\//gm,
		CsingleLineComments			: /\/\/.*$/gm,
		xmlComments					: /(&lt;|<)!--[\s\S]*?--(&gt;|>)/gm,
		singleLinePerlComments		: /#.*$/gm,
		doubleQuotedString			: /"([^\\"\n]|\\.)*"/g,
		multiLineCComments			: /\/\*[\s\S]*?\*\//m,
		singleLineCComments			: /\/\/.*$/m,
		singleLinePerlComments		: /#.*$/m,
		singleQuotedString			: /'([^\\'\n]|\\.)*'/,
		doubleQuotedString			: /"([^\\"\n]|\\.)*"/,
		multiLineDoubleQuotedString	: /"([^\\"]|\\.)*"/,
		multiLineSingleQuotedString	: /'([^\\']|\\.)*'/,
		url							: /&lt;\w+:\/\/[\w-.\/?%&=@:;]*&gt;|\w+:\/\/[\w-.\/?%&=@:;]*/g,
		phpScriptTags 				: { left: /(&lt;|<)\?=?/g, right: /\?(&gt;|>)/g },
		aspScriptTags				: { left: /(&lt;|<)%=?/g, right: /%(&gt;|>)/g },
		scriptScriptTags			: { left: /(&lt;|<)\s*script.*?(&gt;|>)/gi, right: /(&lt;|<)\/\s*script\s*(&gt;|>)/gi }
	}
	this.langLib = {};

	this.langReg = function(lang,rules){
		lang=lang.toLowerCase();
		if(this.langLib.hasOwnProperty(lang)) return false;
		eval('this.langLib.'+lang+'=rules');
		return true;
	}

	this.codeHighLighter = function(code,lang){
		lang = lang.toLowerCase();
		if(!this.langLib.hasOwnProperty(lang)) return code;
		code = code.removeHtmlTag();

		eval('rulesList=this.langLib.'+lang);
		code = this.ruleHandler(code,rulesList);
		return code.addHtmlTag();
	}

	this.ruleHandler = function ruleHandler(str,rules){
		for(var i=0;i<rules.length;i++){
			var rule = rules[i];
			if(!rule) continue;

			if(rule.hasOwnProperty('child')){
				var child=rule.child;
				str = str.replace(rule.pat.valid(),function(){return ruleHandler(arguments[0],child)});
			}else{
				var styleClass;
				if(rule.type && rule.style){
					styleClass = [rule.type,rule.style];
				}else if(rule.type){
					styleClass = rule.type;
				}else{
					return str;
				}

				if(rule.hasOwnProperty('parent')){
					typeVal=rule.parent;
					if(typeVal instanceof Array){
						npat = new RegExp(rule.pat.source+'(?=[^'+rule.parent.join('')+']*?'+rule.parent[1]+')','');
						str = str.xreplace(npat,styleClass);
					}else if(typeVal instanceof String){
						npat = new RegExp(rule.pat.source+'(?=[^'+rule.parent+']*?'+rule.parent+')','');
						alert(npat);
						str = str.xreplace(npat,styleClass);
					}else{
						str = str.xreplace(rule.pat,styleClass,rule.parent);
					}
				}else{
					str = str.xreplace(rule.pat,styleClass);
				}
			}
		}

		return str;
	}



	this.styleToClass = function(style){
		if(style instanceof Array){
			tags =new Array('<'+style.join(' ')+'>','</'+style.join(' ')+'>');
		}else{
			tags =new Array('<'+style+'>','</'+style+'>');
		}
		return tags;
	}

	this.highLightAll = function(){
		for(d=1;d<=ecbox_number;d++){
			EasyCodeClass(d).highLightCode();
		}
		d = null;
	}
}

EasyCodeHighLight = new creatEasyCodeHighLightClass();