<?php
/******* Javascript files**********/

$inline_script = '';
wp_register_script('easycode_codebox',$this->plugindir.'/codebox.js');
wp_enqueue_script('easycode_codebox');
$inline_script .= 'EasyCodeGlobal.pluginDir="'.$this->plugindir.'";EasyCodeGlobal.editCodeNewWindow='.($option['edit_code']-1).';';

//Old highlighter
if($option['highlighter'] == 3){
	wp_register_script('easycode_highlight',$this->plugindir.'/highlight.js');
	wp_enqueue_script('easycode_highlight');
	$inline_script .= 'EasyCodeHighLight.highLightAll();';
}

//SH highlighter
if($option['highlighter'] == 1){
	wp_register_script('easycode_highlight_sh',$this->plugindir.'/sh/shCore.js');
	wp_enqueue_script('easycode_highlight_sh');
	//wp_enqueue_script('easycode_highlight_sh_css',$this->plugindir.'/sh/shBrushCss.js');
	$inline_script .= 'SyntaxHighlighter.highlight();';
}

add_action('wp_print_footer_scripts',
	function() use($inline_script){
		echo '<script type="text/javascript">'.$inline_script.'</script>"';
	}
);



/******** STYLE SHEETS *********/

wp_register_style('easycode_codebox',$this->plugindir.'/codebox.css');
//write inline styles into a string
$inline_css='';


/**Codebox color schemes & Highlight colors**/

if(!$option['use_custom_color']){
	if(!in_array($option['system_color'],$slist=$this->get_style_list())) $option['system_color']='Gray';
	wp_register_style('easycode_boxstyle',$this->plugindir.'/boxstyles/'.$option['system_color'].'.css');

}else{
	$color = &$option['color'];
	$match =array(
		$color['bg'],
		$color['border'],
		$option['border-width'],
		$color['text'],
		$color['side'],
		$color['bga'],
		$color['texta']
	);

	$custom = '
/*EasyCode customized codeBox*/
.easycodebox {background: #%s !important; border:#%s %opx solid !important;}
.easycodebox .headbar, .easycodebox .scrollbox .main ol {color:#%s !important;}
.easycodebox .scrollbox .ecside,.easycodebox .frontmark {background:#%s !important;}
.easycodebox ol li:hover{background:#%s !important; color:#%s !important;}
';
	$inline_css .= vsprintf($custom."\n",$match);

	/**Highlight color scheme**/
	$color = $option['hlcolor'];
	switch($option['highlighter']){
	case 3:  //Use old Js-mini highlighter
		$match = array(
			$color['function'],
			$color['variable'],
			$color['constant'],
			$color['string'],
			$color['number'],
			$color['comment'],
			$color['keyword'],
			$color['important'],
		);
		$custom = '
/*EasyCode Highlight*/
.easycodebox .echl-function{color:#%s;}
.easycodebox .echl-variable{color:#%s;}
.easycodebox .echl-constant{color:#%s;}
.easycodebox .echl-string{color:#%s;}
.easycodebox .echl-number{color:#%s;}
.easycodebox .echl-comment{color:#%s;}
.easycodebox .echl-keyword{color:#%s;}
.easycodebox .echl-important{color:#%s;}
';
		$inline_css .= vsprintf($custom."\n",$match);
	break;

	case 2:  //use GeSHi highlighter
		$css = '
/* EasyCode Highlight -- GeShi Mode*/
 .easycodebox .imp {color: #%s;}
 
 .easycodebox .kw1,.easycodebox .kw2 {color: #%s;} /*keywords*/
 .easycodebox .kw3 {color: #%s;} /*functions*/
 .easycodebox .kw4 {color: #%s;} /*constant*/
 
 .easycodebox .co1,
 .easycodebox .co2,
 .easycodebox .co3,
 .easycodebox .co4,
 .easycodebox .coMULTI {color: #%s;} /*comment*/
 
 .easycodebox .es0,
 .easycodebox .es1,
 .easycodebox .es2,
 .easycodebox .es3,
 .easycodebox .es4,
 .easycodebox .es5,
 .easycodebox .es6,
 .easycodebox .es_h {color: #%s;}
 
 
 .easycodebox .sy0,
 .easycodebox .sy1 {color: #%s;}
 
 .easycodebox .st0,
 .easycodebox .st_h {color: #%s;}
 
 .easycodebox .nu0 ,
 .easycodebox .nu8 ,
 .easycodebox .nu12,
 .easycodebox .nu19 {color:#%s;}
 
 .easycodebox .me1,
 .easycodebox .me2 {color: #%s;}
 
 .easycodebox .re0,
 .easycodebox .re1,
 .easycodebox .re2,
 .easycodebox .re3 {color: #%s;} /*variable*/
 
 .easycodebox .br0 {color: #009900;}
';
		$match = array(
			$color['important'],
			$color['keyword'],
			$color['function'],
			$color['constant'],
			$color['comment'],
			$color['char'],
			$color['symbol'],
			$color['string'],
			$color['number'],
			$color['function'],
			$color['variable'],
		);

		$inline_css .= vsprintf($css."\n",$match);
	break;

	case 1:
		$css = '
/* EasyCode Highlight -- SH Mode*/
 .easycodebox .comments	{color: #%s;}
 .easycodebox .string   {color: #%s;}
 .easycodebox .keyword  {color: #%s;}
 .easycodebox .variable {color: #%s;}
 .easycodebox .value    {color: #%s;}
 .easycodebox .functions{color: #%s;}
 .easycodebox .constants{color: #%s;}
 .easycodebox .color1,
 .easycodebox .operator {color: #%s;}  /*symbols*/
 .easycodebox .color2   {color: #%s;}  /* char */
 .easycodebox .color3   {color: #%s;}  /*important*/
 /*.preprocessor .script*/
';
		$match = array(
			$color['comment'],
			$color['string'],
			$color['keyword'],
			$color['variable'],
			$color['number'],
			$color['function'],
			$color['constant'],
			$color['symbol'],
			$color['char'],
			$color['important'],
		);
		$inline_css .= vsprintf($css."\n",$match);
	break;
	}
}


/**Other options**/

//Convert font options to css font list
$font_list_to_load = $this->get_font_list();
$font_info = $font_list_to_load[$option['font_style']];
if(empty($font_info)){
	$font2css = 'monospace';
}else{
	$font2css = '';
	wp_enqueue_style('easycode_web_font',$this->plugindir."/fonts/$option[font_style]/import.css");
	$font2css .= " '$font_info[1]',".($option['allow-download-font']?"'$font_info[1]_WEB',":'')."$font_info[2]";
}

//Other options
$ol_list_style_type_array = array(0=>'none',1=>'decimal',2=>'decimal-leading-zero');
$match =array(
	$option['nowrap']?'pre':'pre-line',
	$option['nowrap']?'normal':'break-word',
	$option['nowrap']?'keep-all':'break-all',
	$ol_list_style_type_array[$option['rownum']],
	$font2css,
	$option['font-size'],
);
$custom= "
.easycodebox li {white-space:%s !important; word-wrap:%s !important; word-break:%s; list-style-type:%s !important;}
.easycodebox .main ol {font-family:%s !important; font-size: %s%% !important;}
";
$inline_css .= vsprintf($custom,$match)."\n";

//Some messages will fill the headbar without title
$inline_css .= '.easycodebox .headbar .message:after {content:"- '.__('Show or hide the code','easycode').'";}';

/**Finally print inline styles**/
echo '<style type="text/css" style="display:none;" id="easycode_inline_style">'.$inline_css.'</style>';
wp_enqueue_style('easycode_codebox');
wp_enqueue_style('easycode_boxstyle');




/*******EXTRA HTML CODE*********/

//print editing float box
if($option['edit_code']==1){

	$html = '
<div id="EasyCodeTextAreaBox" class="easycode-editor">
	<div class="main">
		<span class="message">'.__('Press Ctrl+C to copy the following code.','easycode').'</span>
		<textarea id="textarea_ec" onmouseover="this.select();"></textarea>
	</div>
	<div class="bgb" onclick="EasyCodeClass().closeEdit();" ></div>
</div>
';
	add_action('wp_footer',
		function() use ($html) {
			echo $html;
		}
	);

}else if($option['edit_code']==2){
	//Maybe someting will be done in future version ...
}
